//****************************************************************************
// @Module        Interrupt Unit
// @Filename      INT.H
// @Project       XC888_Empfaenger_zu_XC167_CAN_Test.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC888CLM-8FF
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description:  This file contains all function prototypes and macros for 
//                the IR module.
//
//----------------------------------------------------------------------------
// @Date          12.04.2007 08:23:59
//
//****************************************************************************

// USER CODE BEGIN (IR_Header,1)

// USER CODE END



#ifndef _INT_H_
#define _INT_H_

//****************************************************************************
// @Project Includes
//****************************************************************************

// USER CODE BEGIN (IR_Header,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (IR_Header,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (IR_Header,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (IR_Header,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (IR_Header,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (IR_Header,7)

// USER CODE END


//****************************************************************************
// @Prototypes Of Global Functions
//****************************************************************************

void INT_vInit(void);

// USER CODE BEGIN (IR_Header,8)

// USER CODE END


//****************************************************************************
// @Macro         INT_vEnableAll() 
//
//----------------------------------------------------------------------------
// @Description   This macro globally enables all interrupts by setting bit 
//                EA.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          12.04.2007
//
//****************************************************************************

#define INT_vEnableAll() EA = 1


//****************************************************************************
// @Macro         INT_vEnableInterrupt(IntName) 
//
//----------------------------------------------------------------------------
// @Description   This macro enables a specific interrupt which is passed in 
//                a parameter. The following constants are available for 
//                'IntName':
//                XINTR6_INT, XINTR10_INT, XINTR11_INT, XINTR12_INT, 
//                XINTR13_INT, T0_INT, T1_INT, XINTR5_INT, UART_INT, SSC_INT, 
//                TASTE, EXTERNAL_INT1, XINTR8_INT, XINTR9_INT
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    IntName: 
//                Name of the Interrupt
//
//----------------------------------------------------------------------------
// @Date          12.04.2007
//
//****************************************************************************

#define INT_vEnableInterrupt(Interrupt) _IE(Interrupt)

#define _IE(Interrupt) ENA_##Interrupt 

#define ENA_TASTE                EX0 = 1       //   Enables External 0 Interrupt
#define ENA_EXTERNAL_INT1        EX1 = 1       //   Enables External 1 Interrupt
#define ENA_XINTR8_INT           EX2 = 1       //   Enables External 2,T21,UART1 and BRG1 Interrupts
#define ENA_XINTR9_INT           EXM = 1       //   Enables External 3,4,5,6 and MultiCAN Node 3 Interrupts
#define ENA_XINTR6_INT           EADC = 1      //   Enables MultiCAN Nodes 1 ,2 and ADC Interrupts
#define ENA_XINTR10_INT          ECCIP0 = 1    //   Enables CCU6 Node 0 and MultiCAN Node 4 Interrupts
#define ENA_XINTR11_INT          ECCIP1 = 1    //   Enables CCU6 Node 1 and MultiCAN Node 5 Interrupts
#define ENA_XINTR12_INT          ECCIP2 = 1    //   Enables CCU6 Node 2 and MultiCAN Node 6 Interrupts
#define ENA_XINTR13_INT          ECCIP3 = 1    //   Enables CCU6 Node 3 and MultiCAN Node 7 Interrupts
#define ENA_T0_INT               ET0 = 1       //   Enables Timer 0 Interrupt
#define ENA_T1_INT               ET1 = 1       //   Enables Timer 1 Interrupt
#define ENA_XINTR5_INT           ET2 = 1       //   Enables T2,BRG and MultiCAN Node 0 Interrupts
#define ENA_UART_INT             ES = 1        //   Enables UART Interrupt
#define ENA_SSC_INT              ESSC = 1      //   Enables SSC Interrupt


//****************************************************************************
// @Interrupt Vectors
//****************************************************************************

#define EXT0INT 0

// USER CODE BEGIN (IR_Header,9)

// USER CODE END

#endif  // ifndef _INT_H_
